#!/usr/bin/perl
use strict;
my %In = ();


my $Mailer = '/sbin/sendmail -t';


$In{email} = $ENV{QUERY_STRING} if ValidEmail($ENV{QUERY_STRING});
&ParseValues;
&CheckRequired;
&SendEmail;
&ThankYouPage;


sub ParseValues
{
	my $buffer;
	if ($ENV{REQUEST_METHOD} eq 'GET') { $buffer = $ENV{QUERY_STRING}; }
	else { read(STDIN,$buffer,$ENV{CONTENT_LENGTH}); }
	my @p = split(/&/,$buffer);
	foreach(@p)
	{
		$_ =~ tr/+/ /;
		my ($n,$v) = split(/=/,$_,2);
		$n =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$In{$n} = $v;
	}
} # sub ParseValues


sub CheckRequired
{
	my @e = ();
	$In{required} =~ s/^[ ,]*(.*?)[ ,]*$/$1/;
	$In{required} =~ s/\s*\,\s*/,/g;
	my @list = split /,+/,$In{required};
	for(@list) { push(@e,qq~Form field "$_" is required~) unless $In{$_} =~ /\w/; }
	push(@e,qq~"$In{email}" is not a valid email address~) unless ValidEmail($In{email});
	WebPageErrorMessage(@e) if @e;
} # sub CheckRequired


sub ValidEmail
{
	return 0 unless $_[0];
	return 0 if $_[0] =~ /(?:[\.\-\_]{2,})|(?:@[\.\-\_])|(?:[\.\-\_]@)|(?:\A\.)/;
	return 1 if $_[0] =~ /^[\w\.\-\_]+\@\[?[\w\.\-\_]+\.(?:[\w\.\-\_]{2,}|[0-9])\]?$/;
	return 0;
} # sub ValidEmail


sub WebPageErrorMessage
{
	my $s = join("</li>\n<li>",@_);
	print "Content-type: text/html\n\n";
	print <<HTML;
<html>
<body bgcolor="white">
<TABLE WIDTH="100%" HEIGHT="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
<TR><TD WIDTH="100%" HEIGHT="100%" ALIGN="CENTER" VALIGN="MIDDLE">
<table border="0" cellpadding="0" cellspacing="0"><tr><td>
<h4>Message:</h4>
<ul>
<li>$s</li>
</ul>
</td></tr></table>
</TD></TR></TABLE>
</body></html>
HTML
	goto BOTTOM;
} # sub WebPageErrorMessage


sub SendEmail
{
	my $email = <<THE_EMAIL;
From: me\@mydomain.com
To: [[email]]
MIME-Version: 1.0
Content-Type: multipart/alternative; boundary="_jkkdsffds32432dlkjifewks_"
Subject: [[firstname]], your requested "Widget by Me" blurb

--_jkkdsffds32432dlkjifewks_
Content-Type: text/plain; charset="iso-8859-1"

Hello [[firstname]],

"Widget by Me" widgets get more and better wids than any 
other widget on the market. And at an attractive price!

Buy a widget now because the current 20% discount special 
is about to expire.

Send money to (bank drafts payable to "Me"):

	Me
	123 Road Ave.
	Anytown, Somewhere
	Country

Or, send money via http://PayPal.com/ to billing\@domain.com

Don't delay, send money today!

Sincerely,

Your enthusiastic widget distributor!

--_jkkdsffds32432dlkjifewks_
Content-Type: text/html; charset="iso-8859-1"

<html>
<body>
<!----------------------------------------
We appologize if you see this message. The 
email was intended to display either plain 
text or HTML, not both. You may ignore the 
rest of the email. The plain text above is 
the complete message intended to reach you.
------------------------------------------>
<p>
Hello <b>[[firstname]]</b>,
</p>
<p>
"Widget by Me" widgets <b>get</b> more and better <b>wids</b> than any 
other widget on the market. And at an attractive price<font size="7">!</font>
</p>
<p>
Buy a widget now because the current <i>20% discount special 
is about to expire.</i>
</p>
<p>
Send money to (bank drafts payable to "Me"):
</p>
<pre>
	Me
	123 Road Ave.
	Anytown, Somewhere
	Country
</pre>
<p>
Or, send money via <a href="http://PayPal.com/">PayPal</a> to billing\@domain.com
</p>
<p>
Don't delay, send money today!
</p>
<p>
Sincerely,
</p>
<p>
Your enthusiastic widget distributor!
</p>
</body>
</html>

--_jkkdsffds32432dlkjifewks_--
THE_EMAIL
	for(keys %In) { $email =~ s/\[\[$_\]\]/$In{$_}/sig; }
	$email =~ s/\[\[.*?\]\]//sig;
	open MAIL,"|$Mailer";
	print MAIL $email;
	close MAIL;
} # sub SendEmail


sub ThankYouPage
{
	if($In{thankyoupage} =~ /\w/)
	{
		$In{thankyoupage} = "http://$In{thankyoupage}" unless $In{thankyoupage} =~ m!^https?://!i;
		print "Location: $In{thankyoupage}\n\n";
		goto BOTTOM;
	}
	else
	{
		print "Content-type: text/html\n\n";
		print '<center>T H A N K &nbsp; Y O U !</center>';
	}
} # sub ThankYouPage


BOTTOM:
# end of script

